
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP数据的提交与过滤基本操作实例详解_php技巧 / iVAN</title>

    <meta name="description" content="PHP数据的提交与过滤基本操作实例详解_php技巧 本文实例讲述了PHP数据的提交与过滤基本操作.分享给大家供大家参考具体如下 1.php提交数据过滤的基本原则 1提交变量进数据库时我们必须使用addslashes()进行过滤像我们的注入问题一个addslashes()也就搞定了.其实在涉及到变量取值时intval()函数对字符串的过滤也是个不错的选择. 2在php.ini中开启magic_quotes_gpc和magic_quotes_runtime.magic_quotes_gpc可以把get,post,cookie里的引号变为斜杠. mag">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PHP数据的提交与过滤基本操作实例详解_php技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文实例讲述了PHP数据的提交与过滤基本操作。分享给大家供大家参考具体如下</p>
<p><strong>1、php提交数据过滤的基本原则</strong></p>
<p>1提交变量进数据库时我们必须使用addslashes()进行过滤像我们的注入问题一个addslashes()也就搞定了。其实在涉及到变量取值时intval()函数对字符串的过滤也是个不错的选择。</p>
<p>2在php.ini中开启magic_quotes_gpc和magic_quotes_runtime。magic_quotes_gpc可以把get,post,cookie里的引号变为斜杠。<br />
magic_quotes_runtime对于进出数据库的数据可以起到格式话的作用。其实早在以前注入很疯狂时这个参数就很流行了。</p>
<p>3在使用系统函数时必须使用escapeshellarg(),escapeshellcmd()参数去过滤这样你也就可以放心的使用系统函数。</p>
<p>4对于跨站strip_tags(),htmlspecialchars()两个参数都不错对于用户提交的的带有html和php的标记都将进行转换。比如尖括号"&lt;"就将转化为 "&lt;"这样无害的字符。</p>
<pre>
$new = htmlspecialchars("&lt;a href='test'&gt;Test&lt;/a&gt;", ENT_QUOTES);
strip_tags($text,);
</pre>
<p>5对于相关函数的过滤就像先前的include(),unlink,fopen()等等只要你把你所要执行操作的变量指定好或者对相关字符过滤严密我想</p>
<p>这样也就无懈可击了。</p>
<p><strong>2、PHP简单的数据过滤</strong></p>
<p>1入库:  trim($str),addslashes($str)</p>
<p>2出库:  stripslashes($str)</p>
<p>3显示:  htmlspecialchars(nl2br($str))</p>
<pre>
&lt;?php
/**
 * global.func.php 公共函数库
 */
/**
 * 返回经addslashes处理过的字符串或数组
 * @param $string 需要处理的字符串或数组
 * @return mixed
 */
function new_addslashes($string){
 if(!is_array($string)) return addslashes($string);
 foreach($string as $key =&gt; $val) $string[$key] = new_addslashes($val);
 return $string;
}
/**
 * 返回经stripslashes处理过的字符串或数组
 * @param $string 需要处理的字符串或数组
 * @return mixed
 */
function new_stripslashes($string) {
 if(!is_array($string)) return stripslashes($string);
 foreach($string as $key =&gt; $val) $string[$key] = new_stripslashes($val);
 return $string;
}
/**
 * 返回经htmlspecialchars处理过的字符串或数组
 * @param $obj 需要处理的字符串或数组
 * @return mixed
 */
function new_html_special_chars($string) {
 $encoding = 'utf-8';
 if(strtolower(CHARSET)=='gbk') $encoding = 'ISO-8859-15';
 if(!is_array($string)) return htmlspecialchars($string,ENT_QUOTES,$encoding);
 foreach($string as $key =&gt; $val) $string[$key] = new_html_special_chars($val);
 return $string;
}
function new_html_entity_decode($string) {
 $encoding = 'utf-8';
 if(strtolower(CHARSET)=='gbk') $encoding = 'ISO-8859-15';
 return html_entity_decode($string,ENT_QUOTES,$encoding);
}
function new_htmlentities($string) {
 $encoding = 'utf-8';
 if(strtolower(CHARSET)=='gbk') $encoding = 'ISO-8859-15';
 return htmlentities($string,ENT_QUOTES,$encoding);
}
/**
 * 安全过滤函数
 *
 * @param $string
 * @return string
 */
function safe_replace($string) {
 $string = str_replace('%20','',$string);
 $string = str_replace('%27','',$string);
 $string = str_replace('%2527','',$string);
 $string = str_replace('*','',$string);
 $string = str_replace('"','"',$string);
 $string = str_replace("'",'',$string);
 $string = str_replace('"','',$string);
 $string = str_replace(';','',$string);
 $string = str_replace('&lt;','&lt;',$string);
 $string = str_replace('&gt;','&gt;',$string);
 $string = str_replace("{",'',$string);
 $string = str_replace('}','',$string);
 $string = str_replace('\\','',$string);
 return $string;
}
/**
 * xss过滤函数
 *
 * @param $string
 * @return string
 */
function remove_xss($string) {
 $string = preg_replace('/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]+/S', '', $string);
 $parm1 = Array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'xml', 'blink', 'link', 'script', 'embed', 'object', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound', 'title', 'base');
 $parm2 = Array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
 $parm = array_merge($parm1, $parm2);
 for ($i = 0; $i &lt; sizeof($parm); $i++) {
  $pattern = '/';
  for ($j = 0; $j &lt; strlen($parm[$i]); $j++) {
   if ($j &gt; 0) {
    $pattern .= '(';
    $pattern .= '([x|X]0([9][a][b]);?)?';
    $pattern .= '|(([9][10][13]);?)?';
    $pattern .= ')?';
   }
   $pattern .= $parm[$i][$j];
  }
  $pattern .= '/i';
  $string = preg_replace($pattern, ' ', $string);
 }
 return $string;
}
/**
 * 过滤ASCII码从0-28的控制字符
 * @return String
 */
function trim_unsafe_control_chars($str) {
 $rule = '/[' . chr ( 1 ) . '-' . chr ( 8 ) . chr ( 11 ) . '-' . chr ( 12 ) . chr ( 14 ) . '-' . chr ( 31 ) . ']*/';
 return str_replace ( chr ( 0 ), '', preg_replace ( $rule, '', $str ) );
}
/**
 * 格式化文本域内容
 *
 * @param $string 文本域内容
 * @return string
 */
function trim_textarea($string) {
 $string = nl2br ( str_replace ( ' ', ' ', $string ) );
 return $string;
}
/**
 * 将文本格式成适合js输出的字符串
 * @param string $string 需要处理的字符串
 * @param intval $isjs 是否执行字符串格式化默认为执行
 * @return string 处理后的字符串
 */
function format_js($string, $isjs = 1) {
 $string = addslashes(str_replace(array("\r", "\n", "\t"), array('', '', ''), $string));
 return $isjs ? 'document.write("'.$string.'");' : $string;
}
/**
 * 转义 javascript 代码标记
 *
 * @param $str
 * @return mixed
 */
 function trim_script($str) {
 if(is_array($str)){
  foreach ($str as $key =&gt; $val){
   $str[$key] = trim_script($val);
  }
  }else{
   $str = preg_replace ( '/\&lt;([\/]?)script([^\&gt;]*?)\&gt;/si', '&lt;\\1script\\2&gt;', $str );
  $str = preg_replace ( '/\&lt;([\/]?)iframe([^\&gt;]*?)\&gt;/si', '&lt;\\1iframe\\2&gt;', $str );
  $str = preg_replace ( '/\&lt;([\/]?)frame([^\&gt;]*?)\&gt;/si', '&lt;\\1frame\\2&gt;', $str );
  $str = str_replace ( 'javascript:', 'javascript', $str );
  }
 return $str;
}
/**
 * 获取当前页面完整URL地址
 */
function get_url() {
 $sys_protocal = isset($_SERVER['SERVER_PORT']) &amp;&amp; $_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://';
 $php_self = $_SERVER['PHP_SELF'] ? safe_replace($_SERVER['PHP_SELF']) : safe_replace($_SERVER['SCRIPT_NAME']);
 $path_info = isset($_SERVER['PATH_INFO']) ? safe_replace($_SERVER['PATH_INFO']) : '';
 $relate_url = isset($_SERVER['REQUEST_URI']) ? safe_replace($_SERVER['REQUEST_URI']) : $php_self.(isset($_SERVER['QUERY_STRING']) ? '?'.safe_replace($_SERVER['QUERY_STRING']) : $path_info);
 return $sys_protocal.(isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : '').$relate_url;
}
/**
 * 字符截取 支持UTF8/GBK
 * @param $string
 * @param $length
 * @param $dot
 */
function str_cut($string, $length, $dot = '...') {
 $strlen = strlen($string);
 if($strlen &lt;= $length) return $string;
 $string = str_replace(array(' ',' ', '&amp;', '"', ''', '“', '”', '—', '&lt;', '&gt;', '·', '…'), array('∵',' ', '&amp;', '"', "'", '“', '”', '—', '&lt;', '&gt;', '·', '…'), $string);
 $strcut = '';
 if(strtolower(CHARSET) == 'utf-8') {
  $length = intval($length-strlen($dot)-$length/3);
  $n = $tn = $noc = 0;
  while($n &lt; strlen($string)) {
   $t = ord($string[$n]);
   if($t == 9 || $t == 10 || (32 &lt;= $t &amp;&amp; $t &lt;= 126)) {
    $tn = 1; $n++; $noc++;
   } elseif(194 &lt;= $t &amp;&amp; $t &lt;= 223) {
    $tn = 2; $n += 2; $noc += 2;
   } elseif(224 &lt;= $t &amp;&amp; $t &lt;= 239) {
    $tn = 3; $n += 3; $noc += 2;
   } elseif(240 &lt;= $t &amp;&amp; $t &lt;= 247) {
    $tn = 4; $n += 4; $noc += 2;
   } elseif(248 &lt;= $t &amp;&amp; $t &lt;= 251) {
    $tn = 5; $n += 5; $noc += 2;
   } elseif($t == 252 || $t == 253) {
    $tn = 6; $n += 6; $noc += 2;
   } else {
    $n++;
   }
   if($noc &gt;= $length) {
    break;
   }
  }
  if($noc &gt; $length) {
   $n -= $tn;
  }
  $strcut = substr($string, 0, $n);
  $strcut = str_replace(array('∵', '&amp;', '"', "'", '“', '”', '—', '&lt;', '&gt;', '·', '…'), array(' ', '&amp;', '"', ''', '“', '”', '—', '&lt;', '&gt;', '·', '…'), $strcut);
 } else {
  $dotlen = strlen($dot);
  $maxi = $length - $dotlen - 1;
  $current_str = '';
  $search_arr = array('&amp;',' ', '"', "'", '“', '”', '—', '&lt;', '&gt;', '·', '…','∵');
  $replace_arr = array('&amp;',' ', '"', ''', '“', '”', '—', '&lt;', '&gt;', '·', '…',' ');
  $search_flip = array_flip($search_arr);
  for ($i = 0; $i &lt; $maxi; $i++) {
   $current_str = ord($string[$i]) &gt; 127 ? $string[$i].$string[++$i] : $string[$i];
   if (in_array($current_str, $search_arr)) {
    $key = $search_flip[$current_str];
    $current_str = str_replace($search_arr[$key], $replace_arr[$key], $current_str);
   }
   $strcut .= $current_str;
  }
 }
 return $strcut.$dot;
}
/**
 * 获取请求ip
 *
 * @return ip地址
 */
function ip() {
 if(getenv('HTTP_CLIENT_IP') &amp;&amp; strcasecmp(getenv('HTTP_CLIENT_IP'), 'unknown')) {
  $ip = getenv('HTTP_CLIENT_IP');
 } elseif(getenv('HTTP_X_FORWARDED_FOR') &amp;&amp; strcasecmp(getenv('HTTP_X_FORWARDED_FOR'), 'unknown')) {
  $ip = getenv('HTTP_X_FORWARDED_FOR');
 } elseif(getenv('REMOTE_ADDR') &amp;&amp; strcasecmp(getenv('REMOTE_ADDR'), 'unknown')) {
  $ip = getenv('REMOTE_ADDR');
 } elseif(isset($_SERVER['REMOTE_ADDR']) &amp;&amp; $_SERVER['REMOTE_ADDR'] &amp;&amp; strcasecmp($_SERVER['REMOTE_ADDR'], 'unknown')) {
  $ip = $_SERVER['REMOTE_ADDR'];
 }
 return preg_match ( '/[\d\.]{7,15}/', $ip, $matches ) ? $matches [0] : '';
}
function get_cost_time() {
 $microtime = microtime ( TRUE );
 return $microtime - SYS_START_TIME;
}
/**
 * 程序执行时间
 *
 * @return int 单位ms
 */
function execute_time() {
 $stime = explode ( ' ', SYS_START_TIME );
 $etime = explode ( ' ', microtime () );
 return number_format ( ($etime [1] + $etime [0] - $stime [1] - $stime [0]), 6 );
}
/**
* 将字符串转换为数组
*
* @param string $data 字符串
* @return array 返回数组格式如果data为空则返回空数组
*/
function string2array($data) {
 if($data == '') return array();
 $data = stripslashes($data);
 @eval("\$array = $data;");
 return $array;
}
/**
* 将数组转换为字符串
*
* @param array $data  数组
* @param bool $isformdata 如果为0则不使用new_stripslashes处理可选参数默认为1
* @return string 返回字符串如果data为空则返回空
*/
function array2string($data, $isformdata = 1) {
 if($data == '') return '';
 if($isformdata) $data = new_stripslashes($data);
 return addslashes(var_export($data, TRUE));
}
/**
* 转换字节数为其他单位
*
*
* @param string $filesize 字节大小
* @return string 返回大小
*/
function sizecount($filesize) {
 if ($filesize &gt;= 1073741824) {
  $filesize = round($filesize / 1073741824 * 100) / 100 .' GB';
 } elseif ($filesize &gt;= 1048576) {
  $filesize = round($filesize / 1048576 * 100) / 100 .' MB';
 } elseif($filesize &gt;= 1024) {
  $filesize = round($filesize / 1024 * 100) / 100 . ' KB';
 } else {
  $filesize = $filesize.' Bytes';
 }
 return $filesize;
}
/**
* 字符串加密、解密函数
*
*
* @param string $txt  字符串
* @param string $operation ENCODE为加密DECODE为解密可选参数默认为ENCODE
* @param string $key  密钥数字、字母、下划线
* @param string $expiry  过期时间
* @return string
*/
function sys_auth($string, $operation = 'ENCODE', $key = '', $expiry = 0) {
 $key_length = 4;
 $key = md5($key != '' ? $key : app_base::load_config('system', 'auth_key'));
 $fixedkey = md5($key);
 $egiskeys = md5(substr($fixedkey, 16, 16));
 $runtokey = $key_length ? ($operation == 'ENCODE' ? substr(md5(microtime(true)), -$key_length) : substr($string, 0, $key_length)) : '';
 $keys = md5(substr($runtokey, 0, 16) . substr($fixedkey, 0, 16) . substr($runtokey, 16) . substr($fixedkey, 16));
 $string = $operation == 'ENCODE' ? sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$egiskeys), 0, 16) . $string : base64_decode(substr($string, $key_length));
 $i = 0; $result = '';
 $string_length = strlen($string);
 for ($i = 0; $i &lt; $string_length; $i++){
  $result .= chr(ord($string{$i}) ^ ord($keys{$i % 32}));
 }
 if($operation == 'ENCODE') {
  return $runtokey . str_replace('=', '', base64_encode($result));
 } else {
  if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() &gt; 0) &amp;&amp; substr($result, 10, 16) == substr(md5(substr($result, 26).$egiskeys), 0, 16)) {
   return substr($result, 26);
  } else {
   return '';
  }
 }
}
/**
* 语言文件处理
*
* @param string  $language 标示符
* @param array  $pars 转义的数组,二维数组 ,'key1'=&gt;'value1','key2'=&gt;'value2',
* @param string  $modules 多个模块之间用半角逗号隔开如member,guestbook
* @return string  语言字符
*/
function L($language = 'no_language',$pars = array(), $modules = '') {
 static $LANG = array();
 static $LANG_MODULES = array();
 static $lang = '';
 if(defined('IN_ADMIN')) {
  $lang = SYS_STYLE ? SYS_STYLE : 'zh-cn';
 } else {
  $lang = app_base::load_config('system','lang');
 }
 if(!$LANG) {
  require_once CODE_PATH.'languages'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.'system.lang.php';
  if(defined('IN_ADMIN')) require_once CODE_PATH.'languages'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.'system_menu.lang.php';
  if(file_exists(CODE_PATH.'languages'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.ROUTE_M.'.lang.php')) require_once CODE_PATH.'languages'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.ROUTE_M.'.lang.php';
 }
 if(!empty($modules)) {
  $modules = explode(',',$modules);
  foreach($modules AS $m) {
   if(!isset($LANG_MODULES[$m])) require_once CODE_PATH.'languages'.DIRECTORY_SEPARATOR.$lang.DIRECTORY_SEPARATOR.$m.'.lang.php';
  }
 }
 if(!array_key_exists($language,$LANG)) {
  return $language;
 } else {
  $language = $LANG[$language];
  if($pars) {
   foreach($pars AS $_k=&gt;$_v) {
    $language = str_replace('{'.$_k.'}',$_v,$language);
   }
  }
  return $language;
 }
}
/**
 * 模板调用
 *
 * @param $module
 * @param $template
 * @param $istag
 * @return unknown_type
 */
function template($module = 'content', $template = 'index', $style = '') {
 if(strpos($module, 'plugin/')!== false) {
  $plugin = str_replace('plugin/', '', $module);
  return p_template($plugin, $template,$style);
 }
 $module = str_replace('/', DIRECTORY_SEPARATOR, $module);
 if(!empty($style) &amp;&amp; preg_match('/([a-z0-9\-_]+)/is',$style)) {
 } elseif (empty($style) &amp;&amp; !defined('STYLE')) {
  if(defined('SITEID')) {
   $siteid = SITEID;
  } else {
   $siteid = param::get_cookie('siteid');
  }
  if (!$siteid) $siteid = 1;
  $sitelist = getcache('sitelist','commons');
  if(!empty($siteid)) {
   $style = $sitelist[$siteid]['default_style'];
  }
 } elseif (empty($style) &amp;&amp; defined('STYLE')) {
  $style = STYLE;
 } else {
  $style = 'default';
 }
 if(!$style) $style = 'default';
 $template_cache = app_base::load_sys_class('template_cache');
 $compiledtplfile = ROOT_PATH.'caches'.DIRECTORY_SEPARATOR.'caches_template'.DIRECTORY_SEPARATOR.$style.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.php';
 if(file_exists(CODE_PATH.'templates'.DIRECTORY_SEPARATOR.$style.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.html')) {
  if(!file_exists($compiledtplfile) || (@filemtime(CODE_PATH.'templates'.DIRECTORY_SEPARATOR.$style.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.html') &gt; @filemtime($compiledtplfile))) {
   $template_cache-&gt;template_compile($module, $template, $style);
  }
 } else {
  $compiledtplfile = ROOT_PATH.'caches'.DIRECTORY_SEPARATOR.'caches_template'.DIRECTORY_SEPARATOR.'default'.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.php';
  if(!file_exists($compiledtplfile) || (file_exists(CODE_PATH.'templates'.DIRECTORY_SEPARATOR.'default'.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.html') &amp;&amp; filemtime(CODE_PATH.'templates'.DIRECTORY_SEPARATOR.'default'.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.html') &gt; filemtime($compiledtplfile))) {
   $template_cache-&gt;template_compile($module, $template, 'default');
  } elseif (!file_exists(CODE_PATH.'templates'.DIRECTORY_SEPARATOR.'default'.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.html')) {
   showmessage('Template does not exist.'.DIRECTORY_SEPARATOR.$style.DIRECTORY_SEPARATOR.$module.DIRECTORY_SEPARATOR.$template.'.html');
  }
 }
 return $compiledtplfile;
}
/**
 * 输出自定义错误
 *
 * @param $errno 错误号
 * @param $errstr 错误描述
 * @param $errfile 报错文件地址
 * @param $errline 错误行号
 * @return string 错误提示
 */
function my_error_handler($errno, $errstr, $errfile, $errline) {
 if($errno==8) return '';
 $errfile = str_replace(ROOT_PATH,'',$errfile);
 if(app_base::load_config('system','errorlog')) {
  error_log('&lt;?php exit;?&gt;'.date('m-d H:i:s',SYS_TIME).' | '.$errno.' | '.str_pad($errstr,30).' | '.$errfile.' | '.$errline."\r\n", 3, CACHE_PATH.'error_log.php');
 } else {
  $str = '&lt;div style="font-size:12px;text-align:left; border-bottom:1px solid #9cc9e0; border-right:1px solid #9cc9e0;padding:1px 4px;color:#000000;font-family:Arial, Helvetica,sans-serif;"&gt;&lt;span&gt;errorno:' . $errno . ',str:' . $errstr . ',file:&lt;font color="blue"&gt;' . $errfile . '&lt;/font&gt;,line' . $errline .'&lt;br /&gt;Need Help?&lt;/span&gt;&lt;/div&gt;';
  echo $str;
 }
}
/**
 * 提示信息页面跳转跳转地址如果传入数组页面会提示多个地址供用户选择默认跳转地址为数组的第一个值时间为5秒。
 * showmessage('登录成功', array('默认跳转地址'=&gt;'http://www.baidu.com'));
 * @param string $msg 提示信息
 * @param mixed(string/array) $url_forward 跳转地址
 * @param int $ms 跳转等待时间
 */
function showmessage($msg, $url_forward = 'goback', $ms = 1250, $dialog = '', $returnjs = '') {
 if(defined('IN_ADMIN')) {
  include(admin::admin_tpl('showmessage', 'admin'));
 } else {
  include(template('content', 'message'));
 }
 exit;
}
/**
 * 查询字符是否存在于某字符串
 *
 * @param $haystack 字符串
 * @param $needle 要查找的字符
 * @return bool
 */
function str_exists($haystack, $needle)
{
 return !(strpos($haystack, $needle) === FALSE);
}
/**
 * 取得文件扩展
 *
 * @param $filename 文件名
 * @return 扩展名
 */
function fileext($filename) {
 return strtolower(trim(substr(strrchr($filename, '.'), 1, 10)));
}
/**
 * 加载模板标签缓存
 * @param string $name 缓存名
 * @param integer $times 缓存时间
 */
function tpl_cache($name,$times = 0) {
 $filepath = 'tpl_data';
 $info = getcacheinfo($name, $filepath);
 if (SYS_TIME - $info['filemtime'] &gt;= $times) {
  return false;
 } else {
  return getcache($name,$filepath);
 }
}
/**
 * 写入缓存默认为文件缓存不加载缓存配置。
 * @param $name 缓存名称
 * @param $data 缓存数据
 * @param $filepath 数据路径模块名称 caches/cache_$filepath/
 * @param $type 缓存类型[file,memcache,apc]
 * @param $config 配置名称
 * @param $timeout 过期时间
 */
function setcache($name, $data, $filepath='', $type='file', $c AND ', $in_column = false) {
 if($in_column &amp;&amp; is_array($data)) {
  $ids = '\''.implode('\',\'', $data).'\'';
  $sql = "$in_column IN ($ids)";
  return $sql;
 } else {
  if ($front == '') {
   $front = ' AND ';
  }
  if(is_array($data) &amp;&amp; count($data) &gt; 0) {
   $sql = '';
   foreach ($data as $key =&gt; $val) {
    $sql .= $sql ? " $front $key = '$val' " : " $key = '$val' ";
   }
   return $sql;
  } else {
   return $data;
  }
 }
}
/**
 * 分页函数
 *
 * @param $num 信息总数
 * @param $curr_page 当前分页
 * @param $perpage 每页显示数
 * @param $urlrule URL规则
 * @param $array 需要传递的数组用于增加额外的方法
 * @return 分页
 */
function pages($num, $curr_page, $perpage = 20, $urlrule = '', $array = array(),$setpages = 10) {
 if(defined('URLRULE') &amp;&amp; $urlrule == '') {
  $urlrule = URLRULE;
  $array = $GLOBALS['URL_ARRAY'];
 } elseif($urlrule == '') {
  $urlrule = url_par('page={$page}');
 }
 $multipage = '';
 if($num &gt; $perpage) {
  $page = $setpages+1;
  $offset = ceil($setpages/2-1);
  $pages = ceil($num / $perpage);
  if (defined('IN_ADMIN') &amp;&amp; !defined('PAGES')) define('PAGES', $pages);
  $from = $curr_page - $offset;
  $to = $curr_page + $offset;
  $more = 0;
  if($page &gt;= $pages) {
   $from = 2;
   $to = $pages-1;
  } else {
   if($from &lt;= 1) {
    $to = $page-1;
    $from = 2;
   } elseif($to &gt;= $pages) {
    $from = $pages-($page-2);
    $to = $pages-1;
   }
   $more = 1;
  }
  //$multipage .= '&lt;a class="a1"&gt;'.$num.L('page_item').'&lt;/a&gt;';
  if($curr_page&gt;0) {
   $multipage .= ' &lt;a href="'.pageurl($urlrule, $curr_page-1, $array).'" class="a1"&gt;'.L('previous').'&lt;/a&gt;';
   if($curr_page==1) {
    $multipage .= ' &lt;span&gt;1&lt;/span&gt;';
   } elseif($curr_page&gt;6 &amp;&amp; $more) {
    $multipage .= ' &lt;a href="'.pageurl($urlrule, 1, $array).'"&gt;1&lt;/a&gt;..';
   } else {
    $multipage .= ' &lt;a href="'.pageurl($urlrule, 1, $array).'"&gt;1&lt;/a&gt;';
   }
  }
  for($i = $from; $i &lt;= $to; $i++) {
   if($i != $curr_page) {
    $multipage .= ' &lt;a href="'.pageurl($urlrule, $i, $array).'"&gt;'.$i.'&lt;/a&gt;';
   } else {
    $multipage .= ' &lt;span&gt;'.$i.'&lt;/span&gt;';
   }
  }
  if($curr_page&lt;$pages) {
   if($curr_page&lt;$pages-5 &amp;&amp; $more) {
    $multipage .= ' ..&lt;a href="'.pageurl($urlrule, $pages, $array).'"&gt;'.$pages.'&lt;/a&gt; &lt;a href="'.pageurl($urlrule, $curr_page+1, $array).'" class="a1"&gt;'.L('next').'&lt;/a&gt;';
   } else {
    $multipage .= ' &lt;a href="'.pageurl($urlrule, $pages, $array).'"&gt;'.$pages.'&lt;/a&gt; &lt;a href="'.pageurl($urlrule, $curr_page+1, $array).'" class="a1"&gt;'.L('next').'&lt;/a&gt;';
   }
  } elseif($curr_page==$pages) {
   $multipage .= ' &lt;span&gt;'.$pages.'&lt;/span&gt; &lt;a href="'.pageurl($urlrule, $curr_page, $array).'" class="a1"&gt;'.L('next').'&lt;/a&gt;';
  } else {
   $multipage .= ' &lt;a href="'.pageurl($urlrule, $pages, $array).'"&gt;'.$pages.'&lt;/a&gt; &lt;a href="'.pageurl($urlrule, $curr_page+1, $array).'" class="a1"&gt;'.L('next').'&lt;/a&gt;';
  }
 }
 return $multipage;
}
function pages1($num, $curr_page, $perpage = 20, $urlrule = '', $array = array(),$setpages = 10) {
 if(defined('URLRULE') &amp;&amp; $urlrule == '') {
  $urlrule = URLRULE;
  $array = $GLOBALS['URL_ARRAY'];
 } elseif($urlrule == '') {
  $urlrule = url_par('page={$page}');
 }
 $multipage = '';
 if($num &gt; $perpage) {
  $page = $setpages+1;
  $offset = ceil($setpages/2-1);
  $pages = ceil($num / $perpage);
  if (defined('IN_ADMIN') &amp;&amp; !defined('PAGES')) define('PAGES', $pages);
  $from = $curr_page - $offset;
  $to = $curr_page + $offset;
  $more = 0;
  if($page &gt;= $pages) {
   $from = 2;
   $to = $pages-1;
  } else {
   if($from &lt;= 1) {
    $to = $page-1;
    $from = 2;
   } elseif($to &gt;= $pages) {
    $from = $pages-($page-2);
    $to = $pages-1;
   }
   $more = 1;
  }
  //$multipage .= '&lt;a class="a1"&gt;'.$num.L('page_item').'&lt;/a&gt;';
  if($curr_page&gt;0) {
   $multipage .= ' &lt;a href="###" class="a1"&gt;'.L('previous').'&lt;/a&gt;';
   if($curr_page==1) {
    $multipage .= ' &lt;span&gt;1&lt;/span&gt;';
   } elseif($curr_page&gt;6 &amp;&amp; $more) {
    $multipage .= ' &lt;a href="###" /a&gt;..';
   } else {
    $multipage .= ' &lt;a href="###" /a&gt;';
   }
  }
  for($i = $from; $i &lt;= $to; $i++) {
   if($i != $curr_page) {
    $multipage .= ' &lt;a href="###" /a&gt;';
   } else {
    $multipage .= ' &lt;span&gt;'.$i.'&lt;/span&gt;';
   }
  }
  if($curr_page&lt;$pages) {
   if($curr_page&lt;$pages-5 &amp;&amp; $more) {
    $multipage .= ' ..&lt;a href="###" /a&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
   } else {
    $multipage .= ' &lt;a href="###" /a&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
   }
  } elseif($curr_page==$pages) {
   $multipage .= ' &lt;span&gt;'.$pages.'&lt;/span&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
  } else {
   $multipage .= ' &lt;a href="###" /a&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
  }
 }
 return $multipage;
}
function pages2($num, $curr_page, $pages, $urlrule = '', $array = array(),$setpages = 10) {
 if(defined('URLRULE') &amp;&amp; $urlrule == '') {
  $urlrule = URLRULE;
  $array = $GLOBALS['URL_ARRAY'];
 } elseif($urlrule == '') {
  $urlrule = url_par('page={$page}');
 }
 $multipage = '';
 if($pages &gt; 1) {
  $page = $setpages+1;
  $offset = ceil($setpages/2-1);
  if (defined('IN_ADMIN') &amp;&amp; !defined('PAGES')) define('PAGES', $pages);
  $from = $curr_page - $offset;
  $to = $curr_page + $offset;
  $more = 0;
  if($page &gt;= $pages) {
   $from = 2;
   $to = $pages-1;
  } else {
   if($from &lt;= 1) {
    $to = $page-1;
    $from = 2;
   } elseif($to &gt;= $pages) {
    $from = $pages-($page-2);
    $to = $pages-1;
   }
   $more = 1;
  }
  //$multipage .= '&lt;a class="a1"&gt;'.$num.L('page_item').'&lt;/a&gt;';
  if($curr_page&gt;0) {
   $multipage .= ' &lt;a href="###" class="a1"&gt;'.L('previous').'&lt;/a&gt;';
   if($curr_page==1) {
    $multipage .= ' &lt;span&gt;1&lt;/span&gt;';
   } elseif($curr_page&gt;6 &amp;&amp; $more) {
    $multipage .= ' &lt;a href="###" /a&gt;..';
   } else {
    $multipage .= ' &lt;a href="###" /a&gt;';
   }
  }
  for($i = $from; $i &lt;= $to; $i++) {
   if($i != $curr_page) {
    $multipage .= ' &lt;a href="###" /a&gt;';
   } else {
    $multipage .= ' &lt;span&gt;'.$i.'&lt;/span&gt;';
   }
  }
  if($curr_page&lt;$pages) {
   if($curr_page&lt;$pages-5 &amp;&amp; $more) {
    $multipage .= ' ..&lt;a href="###" /a&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
   } else {
    $multipage .= ' &lt;a href="###" /a&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
   }
  } elseif($curr_page==$pages) {
   $multipage .= ' &lt;span&gt;'.$pages.'&lt;/span&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
  } else {
   $multipage .= ' &lt;a href="###" /a&gt; &lt;a href="###" class="a1"&gt;'.L('next').'&lt;/a&gt;';
  }
 }
 return $multipage;
}
/**
 * 返回分页路径
 *
 * @param $urlrule 分页规则
 * @param $page 当前页
 * @param $array 需要传递的数组用于增加额外的方法
 * @return 完整的URL路径
 */
function pageurl($urlrule, $page, $array = array()) {
 if(strpos($urlrule, '~')) {
  $urlrules = explode('~', $urlrule);
  $urlrule = $page &lt; 2 ? $urlrules[0] : $urlrules[1];
 }
 $findme = array('{$page}');
 $replaceme = array($page);
 if (is_array($array)) foreach ($array as $k=&gt;$v) {
  $findme[] = '{$'.$k.'}';
  $replaceme[] = $v;
 }
 $url = str_replace($findme, $replaceme, $urlrule);
 $url = str_replace(array('http://','//','~'), array('~','/','http://'), $url);
 return $url;
}
/**
 * URL路径解析pages 函数的辅助函数
 *
 * @param $par 传入需要解析的变量 默认为page={$page}
 * @param $url URL地址
 * @return URL
 */
function url_par($par, $url = '') {
 if($url == '') $url = get_url();
 $pos = strpos($url, '?');
 if($pos === false) {
  $url .= '?'.$par;
 } else {
  $querystring = substr(strstr($url, '?'), 1);
  parse_str($querystring, $pars);
  $query_array = array();
  foreach($pars as $k=&gt;$v) {
   if($k != 'page') $query_array[$k] = $v;
  }
  $querystring = http_build_query($query_array).'&amp;'.$par;
  $url = substr($url, 0, $pos).'?'.$querystring;
 }
 return $url;
}
/**
 * 判断email格式是否正确
 * @param $email
 */
function is_email($email) {
 return strlen($email) &gt; 6 &amp;&amp; preg_match("/^[\w\-\.]+@[\w\-\.]+(\.\w+)+$/", $email);
}
/**
 * iconv 编辑转换
 */
if (!function_exists('iconv')) {
 function iconv($in_charset, $out_charset, $str) {
  $in_charset = strtoupper($in_charset);
  $out_charset = strtoupper($out_charset);
  if (function_exists('mb_convert_encoding')) {
   return mb_convert_encoding($str, $out_charset, $in_charset);
  } else {
   app_base::load_sys_func('iconv');
   $in_charset = strtoupper($in_charset);
   $out_charset = strtoupper($out_charset);
   if ($in_charset == 'UTF-8' &amp;&amp; ($out_charset == 'GBK' || $out_charset == 'GB2312')) {
    return utf8_to_gbk($str);
   }
   if (($in_charset == 'GBK' || $in_charset == 'GB2312') &amp;&amp; $out_charset == 'UTF-8') {
    return gbk_to_utf8($str);
   }
   return $str;
  }
 }
}
/**
 * 代码广告展示函数
 * @param intval $siteid 所属站点
 * @param intval $id 广告ID
 * @return 返回广告代码
 */
function show_ad($siteid, $id) {
 $siteid = intval($siteid);
 $id = intval($id);
 if(!$id || !$siteid) return false;
 $p = app_base::load_model('poster_model');
 $r = $p-&gt;get_one(array('spaceid'=&gt;$id, 'siteid'=&gt;$siteid), 'disabled, setting', 'id ASC');
 if ($r['disabled']) return '';
 if ($r['setting']) {
  $c = string2array($r['setting']);
 } else {
  $r['code'] = '';
 }
 return $c['code'];
}
/**
 * 获取当前的站点ID
 */
function get_siteid() {
 static $siteid;
 if (!empty($siteid)) return $siteid;
 if (defined('IN_ADMIN')) {
  if ($d = param::get_cookie('siteid')) {
   $siteid = $d;
  } else {
   return '';
  }
 } else {
  $data = getcache('sitelist', 'commons');
  if(!is_array($data)) return '1';
  $site_url = SITE_PROTOCOL.SITE_URL;
  foreach ($data as $v) {
   if ($v['url'] == $site_url.'/') $siteid = $v['siteid'];
  }
 }
 if (empty($siteid)) $siteid = 1;
 return $siteid;
}
/**
 * 获取用户昵称
 * 不传入userid取当前用户nickname,如果nickname为空取username
 * 传入field取用户$field字段信息
 */
function get_nickname($userid='', $field='') {
 $return = '';
 if(is_numeric($userid)) {
  $member_db = app_base::load_model('member_model');
  $memberinfo = $member_db-&gt;get_one(array('userid'=&gt;$userid));
  if(!empty($field) &amp;&amp; $field != 'nickname' &amp;&amp; isset($memberinfo[$field]) &amp;&amp;!empty($memberinfo[$field])) {
   $return = $memberinfo[$field];
  } else {
   $return = isset($memberinfo['nickname']) &amp;&amp; !empty($memberinfo['nickname']) ? $memberinfo['nickname'].'('.$memberinfo['username'].')' : $memberinfo['username'];
  }
 } else {
  if (param::get_cookie('_nickname')) {
   $return .= '('.param::get_cookie('_nickname').')';
  } else {
   $return .= '('.param::get_cookie('_username').')';
  }
 }
 return $return;
}
/**
 * 获取用户信息
 * 不传入$field返回用户所有信息,
 * 传入field取用户$field字段信息
 */
function get_memberinfo($userid, $field='') {
 if(!is_numeric($userid)) {
  return false;
 } else {
  static $memberinfo;
  if (!isset($memberinfo[$userid])) {
   $member_db = app_base::load_model('member_model');
   $memberinfo[$userid] = $member_db-&gt;get_one(array('userid'=&gt;$userid));
  }
  if(!empty($field) &amp;&amp; !empty($memberinfo[$userid][$field])) {
   return $memberinfo[$userid][$field];
  } else {
   return $memberinfo[$userid];
  }
 }
}
/**
 * 通过 username 值获取用户所有信息
 * 获取用户信息
 * 不传入$field返回用户所有信息,
 * 传入field取用户$field字段信息
 */
function get_memberinfo_buyusername($username, $field='') {
 if(empty($username)){return false;}
 static $memberinfo;
 if (!isset($memberinfo[$username])) {
  $member_db = app_base::load_model('member_model');
  $memberinfo[$username] = $member_db-&gt;get_one(array('username'=&gt;$username));
 }
 if(!empty($field) &amp;&amp; !empty($memberinfo[$username][$field])) {
  return $memberinfo[$username][$field];
 } else {
  return $memberinfo[$username];
 }
}
/**
 * 调用关联菜单
 * @param $linkageid 联动菜单id
 * @param $id 生成联动菜单的样式id
 * @param $defaultvalue 默认值
 */
function menu_linkage($linkageid = 0, $id = 'linkid', $defaultvalue = 0, $defaultlabel = array()) {
 $linkageid = intval($linkageid);
 $datas = array();
 $datas = getcache($linkageid,'linkage');
 $infos = $datas['data'];
 if($datas['style']=='1') {
  $title = $datas['title'];
  $container = 'content'.create_randomnum(100, 999).date('is');
  if(!defined('DIALOG_INIT_1')) {
   define('DIALOG_INIT_1', 1);
   $string .= '&lt;script type="text/javascript" src="'.JS_PATH.'dialog.js"&gt;&lt;/script&gt;';
   //TODO $string .= '&lt;link href="'.CSS_PATH.'dialog.css" rel="stylesheet" type="text/css"&gt;';
  }
  if(!defined('LINKAGE_INIT_1')) {
   define('LINKAGE_INIT_1', 1);
   $string .= '&lt;script type="text/javascript" src="'.JS_PATH.'linkage/js/pop.js"&gt;&lt;/script&gt;';
  }
  $var_div = $defaultvalue &amp;&amp; (ROUTE_A=='edit' || ROUTE_A=='account_manage_info' || ROUTE_A=='info_publish' || ROUTE_A=='orderinfo') ? menu_linkage_level($defaultvalue,$linkageid,$infos) : $datas['title'];
  $var_input = $defaultvalue &amp;&amp; (ROUTE_A=='edit' || ROUTE_A=='account_manage_info' || ROUTE_A=='info_publish') ? '&lt;input type="hidden" name="info['.$id.']" value="'.$defaultvalue.'"&gt;' : '&lt;input type="hidden" name="info['.$id.']" value=""&gt;';
  $string .= '&lt;div name="'.$id.'" value="" id="'.$id.'" class="ib"&gt;'.$var_div.'&lt;/div&gt;'.$var_input.' &lt;input type="button" name="btn_'.$id.'" class="button" value="'.L('linkage_select').'" &gt;  $string .= '&lt;script type="text/javascript"&gt;';
  $string .= 'var returnid_'.$id.'= \''.$id.'\';';
  $string .= 'var returnkeyid_'.$id.' = \''.$linkageid.'\';';
  $string .= 'var '.$container.' = new Array(';
  foreach($infos AS $k=&gt;$v) {
   if($v['parentid'] == 0) {
    $s[]='new Array(\''.$v['linkageid'].'\',\''.$v['name'].'\',\''.$v['parentid'].'\')';
   } else {
    continue;
   }
  }
  $s = implode(',',$s);
  $string .=$s;
  $string .= ')';
  $string .= '&lt;/script&gt;';
 } elseif($datas['style']=='2') {
  if(!defined('LINKAGE_INIT_1')) {
   define('LINKAGE_INIT_1', 1);
   $string .= '&lt;script type="text/javascript" src="'.JS_PATH.'linkage/js/jquery.ld.js"&gt;&lt;/script&gt;';
  }
  $default_txt = '';
  if($defaultvalue) {
    $default_txt = menu_linkage_level($defaultvalue,$linkageid,$infos);
    $default_txt = '["'.str_replace(' &gt; ','","',$default_txt).'"]';
  }
  $string .= $defaultvalue &amp;&amp; (ROUTE_A=='edit' || ROUTE_A=='account_manage_info' || ROUTE_A=='info_publish') ? '&lt;input type="hidden" name="info['.$id.']" id="'.$id.'" value="'.$defaultvalue.'"&gt;' : '&lt;input type="hidden" name="info['.$id.']" id="'.$id.'" value=""&gt;';
  for($i=1;$i&lt;=$datas['setting']['level'];$i++) {
   $txt = isset($defaultlabel[$i]) ? $defaultlabel[$i] : '请选择';
   $string .='&lt;select class="pc-select-'.$id.'" name="'.$id.'-'.$i.'" id="'.$id.'-'.$i.'" width="100"&gt;&lt;option value=""&gt;' . $txt . '&lt;/option&gt;&lt;/select&gt; ';
  }
  $string .= '&lt;script type="text/javascript"&gt;
     $(function(){
      var $ld5 = $(".pc-select-'.$id.'");
      $ld5.ld({ajaxOptions : {"url" : "'.APP_PATH.'api.php?op=get_linkage&amp;act=ajax_select&amp;keyid='.$linkageid.'"},defaultParentId : 0,style : {"width" : 120}})
      var ld5_api = $ld5.ld("api");
      //ld5_api.selected('.$default_txt.');
      $ld5.bind("change",onchange);
      function onchange(e){
       var $target = $(e.target);
       var index = $ld5.index($target);
       $("#'.$id.'-'.$i.'").remove();
       $("#'.$id.'").val($ld5.eq(index).show().val());
       index ++;
       $ld5.eq(index).show();        }
     })
  &lt;/script&gt;';
 } else {
  $title = $defaultvalue ? $infos[$defaultvalue]['name'] : $datas['title'];
  $colObj = create_randomnum(100, 999).date('is');
  $string = '';
  if(!defined('LINKAGE_INIT')) {
   define('LINKAGE_INIT', 1);
   $string .= '&lt;script type="text/javascript" src="'.JS_PATH.'linkage/js/mln.colselect.js"&gt;&lt;/script&gt;';
   if(defined('IN_ADMIN')) {
    $string .= '&lt;link href="'.JS_PATH.'linkage/style/admin.css" rel="stylesheet" type="text/css"&gt;';
   } else {
    $string .= '&lt;link href="'.JS_PATH.'linkage/style/css.css" rel="stylesheet" type="text/css"&gt;';
   }
  }
  $string .= '&lt;input type="hidden" name="info['.$id.']" value="1"&gt;&lt;div id="'.$id.'"&gt;&lt;/div&gt;';
  $string .= '&lt;script type="text/javascript"&gt;';
  $string .= 'var colObj'.$colObj.' = {"Items":[';
  foreach($infos AS $k=&gt;$v) {
   $s .= '{"name":"'.$v['name'].'","topid":"'.$v['parentid'].'","colid":"'.$k.'","value":"'.$k.'","fun":function(){}},';
  }
  $string .= substr($s, 0, -1);
  $string .= ']};';
  $string .= '$("#'.$id.'").mlnColsel(colObj'.$colObj.',{';
  $string .= 'title:"'.$title.'",';
  $string .= 'value:"'.$defaultvalue.'",';
  $string .= 'width:100';
  $string .= '});';
  $string .= '&lt;/script&gt;';
 }
 return $string;
}
/**
 * 联动菜单层级
 */
function menu_linkage_level($linkageid,$keyid,$infos,$result=array()) {
 if(array_key_exists($linkageid,$infos)) {
  $result[]=$infos[$linkageid]['name'];
  return menu_linkage_level($infos[$linkageid]['parentid'],$keyid,$infos,$result);
 }
 krsort($result);
 return implode(' &gt; ',$result);
}
/**
 * 通过catid获取显示菜单完整结构
 * @param $menuid 菜单ID
 * @param $cache_file 菜单缓存文件名称
 * @param $cache_path 缓存文件目录
 * @param $key 取得缓存值的键值名称
 * @param $parentkey 父级的ID
 * @param $linkstring 链接字符
 */
function menu_level($menuid, $cache_file, $cache_path = 'commons', $key = 'catname', $parentkey = 'parentid', $linkstring = ' &gt; ', $result=array()) {
 $menu_arr = getcache($cache_file, $cache_path);
 if (array_key_exists($menuid, $menu_arr)) {
  $result[] = $menu_arr[$menuid][$key];
  return menu_level($menu_arr[$menuid][$parentkey], $cache_file, $cache_path, $key, $parentkey, $linkstring, $result);
 }
 krsort($result);
 return implode($linkstring, $result);
}
/**
 * 通过id获取显示联动菜单
 * @param $linkageid 联动菜单ID
 * @param $keyid 菜单keyid
 * @param $space 菜单间隔符
 * @param $tyoe 1 返回间隔符链接完整路径名称 3 返回完整路径数组2返回当前联动菜单名称4 直接返回ID
 * @param $result 递归使用字段1
 * @param $infos 递归使用字段2
 */
function get_linkage($linkageid, $keyid, $space = '&gt;', $type = 1, $result = array(), $infos = array()) {
 if($space=='' || !isset($space))$space = '&gt;';
 if(!$infos) {
  $datas = getcache($keyid,'linkage');
  $infos = $datas['data'];
 }
 if($type == 1 || $type == 3 || $type == 4) {
  if(array_key_exists($linkageid,$infos)) {
   $result[]= ($type == 1) ? $infos[$linkageid]['name'] : (($type == 4) ? $linkageid :$infos[$linkageid]);
   return get_linkage($infos[$linkageid]['parentid'], $keyid, $space, $type, $result, $infos);
  } else {
   if(count($result)&gt;0) {
    krsort($result);
    if($type == 1 || $type == 4) $result = implode($space,$result);
    return $result;
   } else {
    return $result;
   }
  }
 } else {
  return $infos[$linkageid]['name'];
 }
}
/**
 * IE浏览器判断
 */
function is_ie() {
 $useragent = strtolower($_SERVER['HTTP_USER_AGENT']);
 if((strpos($useragent, 'opera') !== false) || (strpos($useragent, 'konqueror') !== false)) return false;
 if(strpos($useragent, 'msie ') !== false) return true;
 return false;
}
/**
 * 文件下载
 * @param $filepath 文件路径
 * @param $filename 文件名称
 */
function file_down($filepath, $filename = '') {
 if(!$filename) $filename = basename($filepath);
 if(is_ie()) $filename = rawurlencode($filename);
 $filetype = fileext($filename);
 $filesize = sprintf("%u", filesize($filepath));
 if(ob_get_length() !== false) @ob_end_clean();
 header('Pragma: public');
 header('Last-Modified: '.gmdate('D, d M Y H:i:s') . ' GMT');
 header('Cache-Control: no-store, no-cache, must-revalidate');
 header('Cache-Control: pre-check=0, post-check=0, max-age=0');
 header('Content-Transfer-Encoding: binary');
 header('Content-Encoding: none');
 header('Content-type: '.$filetype);
 header('Content-Disposition: attachment; filename="'.$filename.'"');
 header('Content-length: '.$filesize);
 readfile($filepath);
 exit;
}
/**
 * 判断字符串是否为utf8编码英文和半角字符返回ture
 * @param $string
 * @return bool
 */
function is_utf8($string) {
 return preg_match('%^(?:
     [\x09\x0A\x0D\x20-\x7E] # ASCII
     | [\xC2-\xDF][\x80-\xBF] # non-overlong 2-byte
     | \xE0[\xA0-\xBF][\x80-\xBF] # excluding overlongs
     | [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2} # straight 3-byte
     | \xED[\x80-\x9F][\x80-\xBF] # excluding surrogates
     | \xF0[\x90-\xBF][\x80-\xBF]{2} # planes 1-3
     | [\xF1-\xF3][\x80-\xBF]{3} # planes 4-15
     | \xF4[\x80-\x8F][\x80-\xBF]{2} # plane 16
     )*$%xs', $string);
}
/**
 * 组装生成ID号
 * @param $modules 模块名
 * @param $contentid 内容ID
 * @param $siteid 站点ID
 */
function id_encode($modules,$contentid, $siteid) {
 return urlencode($modules.'-'.$contentid.'-'.$siteid);
}
/**
 * 解析ID
 * @param $id 评论ID
 */
function id_decode($id) {
 return explode('-', $id);
}
/**
 * 对用户的密码进行加密
 * @param $password
 * @param $encrypt //传入加密串在修改密码时做认证
 * @return array/password
 */
function password($password, $encrypt='') {
 $pwd = array();
 $pwd['encrypt'] = $encrypt ? $encrypt : create_randomstr();
 $pwd['password'] = md5(md5(trim($password)).$pwd['encrypt']);
 return $encrypt ? $pwd['password'] : $pwd;
}
/**
 * 生成随机字符串
 * @param string $lenth 长度
 * @return string 字符串
 */
function create_randomstr($lenth = 6) {
 //openssl_random_pseudo_bytes
 $fp = @fopen('/dev/urandom','rb');
 $pr_bits = '';
 if ($fp !== FALSE) {
  $pr_bits .= @fread($fp,$lenth/2);
  @fclose($fp);
 }
 return bin2hex($pr_bits);
 //return random($lenth, '123456789abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ');
}
/**
 * 生成随机数
 * @param string $lenth 长度
 * @return string 字符串
 */
function create_randomnum($min,$max) {
 //openssl_random_pseudo_bytes
 $difference = $max-$min;
 $bytesNeeded = ceil($difference/256);
 $fp = @fopen('/dev/urandom','rb');
 if ($fp !== FALSE) {
  $randomBytes = @fread($fp,$bytesNeeded);
  @fclose($fp);
 }
 $sum = 0;
 for ($a = 0; $a &lt; $bytesNeeded; $a++){
  $sum += ord($randomBytes[$a]);
 }
 $sum = $sum % ($difference);
 return $sum + $min;
 //return random($lenth, '123456789abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ');
}
/**
 * 检查密码长度是否符合规定
 *
 * @param STRING $password
 * @return  TRUE or FALSE
 */
function is_password($password) {
 $strlen = strlen($password);
 if($strlen &gt;= 6 &amp;&amp; $strlen &lt;= 20) return true;
 return false;
}
 /**
 * 检测输入中是否含有错误字符
 *
 * @param char $string 要检查的字符串名称
 * @return TRUE or FALSE
 */
function is_badword($string) {
 $badwords = array("\\",'&amp;',' ',"'",'"','/','*',',','&lt;','&gt;',"\r","\t","\n","#");
 foreach($badwords as $value){
  if(strpos($string, $value) !== FALSE) {
   return TRUE;
  }
 }
 return FALSE;
}
/**
 * 检查用户名是否符合规定
 *
 * @param STRING $username 要检查的用户名
 * @return  TRUE or FALSE
 */
function is_username($username) {
 $strlen = strlen($username);
 if(is_badword($username) || !preg_match("/^[a-zA-Z0-9_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]+$/", $username)){
  return false;
 } elseif ( 20 &lt; $strlen || $strlen &lt; 2 ) {
  return false;
 }
 return true;
}
/**
 * 检查id是否存在于数组中
 *
 * @param $id
 * @param $ids
 * @param $s
 */
function check_in($id, $ids = '', $s = ',') {
 if(!$ids) return false;
 $ids = explode($s, $ids);
 return is_array($id) ? array_intersect($id, $ids) : in_array($id, $ids);
}
/**
 * 对数据进行编码转换
 * @param array/string $data  数组
 * @param string $input  需要转换的编码
 * @param string $output 转换后的编码
 */
function array_iconv($data, $input = 'gbk', $output = 'utf-8') {
 if (!is_array($data)) {
  return iconv($input, $output, $data);
 } else {
  foreach ($data as $key=&gt;$val) {
   if(is_array($val)) {
    $data[$key] = array_iconv($val, $input, $output);
   } else {
    $data[$key] = iconv($input, $output, $val);
   }
  }
  return $data;
 }
}
/**
 * 生成缩略图函数
 * @param $imgurl 图片路径
 * @param $width 缩略图宽度
 * @param $height 缩略图高度
 * @param $autocut 是否自动裁剪 默认裁剪当高度或宽度有一个数值为0是自动关闭
 * @param $smallpic 无图片是默认图片路径
 */
function thumb($imgurl, $width = 100, $height = 100 ,$autocut = 1, $smallpic = 'nopic.gif') {
 global $image;
 $upload_url = app_base::load_config('system','upload_url');
 $upload_path = app_base::load_config('system','upload_path');
 if(empty($imgurl)) return IMG_PATH.$smallpic;
 $imgurl_replace= str_replace($upload_url, '', $imgurl);
 if(!extension_loaded('gd') || strpos($imgurl_replace, '://')) return $imgurl;
 if(!file_exists($upload_path.$imgurl_replace)) return IMG_PATH.$smallpic;
 list($width_t, $height_t, $type, $attr) = getimagesize($upload_path.$imgurl_replace);
 if($width&gt;=$width_t || $height&gt;=$height_t) return $imgurl;
 $newimgurl = dirname($imgurl_replace).'/thumb_'.$width.'_'.$height.'_'.basename($imgurl_replace);
 if(file_exists($upload_path.$newimgurl)) return $upload_url.$newimgurl;
 if(!is_object($image)) {
  app_base::load_sys_class('image','','0');
  $image = new image(1,0);
 }
 return $image-&gt;thumb($upload_path.$imgurl_replace, $upload_path.$newimgurl, $width, $height, '', $autocut) ? $upload_url.$newimgurl : $imgurl;
}
/**
 * 水印添加
 * @param $source 原图片路径
 * @param $target 生成水印图片途径默认为空覆盖原图
 * @param $siteid 站点id系统需根据站点id获取水印信息
 */
function watermark($source, $target = '',$siteid) {
 global $image_w;
 if(empty($source)) return $source;
 if(!extension_loaded('gd') || strpos($source, '://')) return $source;
 if(!$target) $target = $source;
 if(!is_object($image_w)){
  app_base::load_sys_class('image','','0');
  $image_w = new image(0,$siteid);
 }
  $image_w-&gt;watermark($source, $target);
 return $target;
}
/**
 * 当前路径
 * 返回指定栏目路径层级
 * @param $catid 栏目id
 * @param $symbol 栏目间隔符
 */
function catpos($catid, $symbol=' &gt; '){
 $category_arr = array();
 $siteids = getcache('category_content','commons');
 $siteid = $siteids[$catid];
 $category_arr = getcache('category_content_'.$siteid,'commons');
 if(!isset($category_arr[$catid])) return '';
 $pos = '';
 $siteurl = siteurl($category_arr[$catid]['siteid']);
 $arrparentid = array_filter(explode(',', $category_arr[$catid]['arrparentid'].','.$catid));
 foreach($arrparentid as $catid) {
  $url = $category_arr[$catid]['url'];
 // if(strpos($url, '://') === false) $url = $siteurl.$url;
  $pos .= '&lt;a href="'.$url.'"&gt;'.$category_arr[$catid]['catname'].'&lt;/a&gt;'.$symbol;
 }
 return $pos;
}
/**
 * 根据catid获取子栏目数据的sql语句
 * @param string $module 缓存文件名
 * @param intval $catid 栏目ID
 */
function get_sql_catid($file = 'category_content_1', $catid = 0, $module = 'commons') {
 $category = getcache($file,$module);
 $catid = intval($catid);
 if(!isset($category[$catid])) return false;
 return $category[$catid]['child'] ? " catid IN(".$category[$catid]['arrchildid'].") " : " catid=$catid ";
}
/**
 * 获取子栏目
 * @param $parentid 父级id
 * @param $type 栏目类型
 * @param $self 是否包含本身 0为不包含
 * @param $siteid 站点id
 */
function subcat($parentid = NULL, $type = NULL,$self = '0', $siteid = '') {
 if (empty($siteid)) $siteid = get_siteid();
 $category = getcache('category_content_'.$siteid,'commons');
 foreach($category as $id=&gt;$cat) {
  if($cat['siteid'] == $siteid &amp;&amp; ($parentid === NULL || $cat['parentid'] == $parentid) &amp;&amp; ($type === NULL || $cat['type'] == $type)) $subcat[$id] = $cat;
  if($self == 1 &amp;&amp; $cat['catid'] == $parentid &amp;&amp; !$cat['child']) $subcat[$id] = $cat;
 }
 return $subcat;
}
/**
 * 获取内容地址
 * @param $catid 栏目ID
 * @param $id  文章ID
 * @param $allurl 是否以绝对路径返回
 */
function go($catid,$id, $allurl = 0) {
 static $category;
 if(empty($category)) {
  $siteids = getcache('category_content','commons');
  $siteid = $siteids[$catid];
  $category = getcache('category_content_'.$siteid,'commons');
 }
 $id = intval($id);
 if(!$id || !isset($category[$catid])) return '';
 $modelid = $category[$catid]['modelid'];
 if(!$modelid) return '';
 $db = app_base::load_model('content_model');
 $db-&gt;set_model($modelid);
 $r = $db-&gt;setCache()-&gt;get_one(array('id'=&gt;$id), 'url');
 if (!empty($allurl)) {
  if (strpos($r['url'], '://')===false) {
   if (strpos($category[$catid]['url'], '://') === FALSE) {
    $site = siteinfo($category[$catid]['siteid']);
    $r['url'] = substr($site['domain'], 0, -1).$r['url'];
   } else {
    $r['url'] = $category[$catid]['url'].$r['url'];
   }
  }
 }
 return $r['url'];
}
/**
 * 将附件地址转换为绝对地址
 * @param $path 附件地址
 */
function atturl($path) {
 if(strpos($path, ':/')) {
  return $path;
 } else {
  $sitelist = getcache('sitelist','commons');
  $siteid = get_siteid();
  $siteurl = $sitelist[$siteid]['domain'];
  $domainlen = strlen($sitelist[$siteid]['domain'])-1;
  $path = $siteurl.$path;
  $path = substr_replace($path, '/', strpos($path, '//',$domainlen),2);
  return  $path;
 }
}
/**
 * 判断模块是否安装
 * @param $m 模块名称
 */
function module_exists($m = '') {
 if ($m=='admin') return true;
 $modules = getcache('modules', 'commons');
 $modules = array_keys($modules);
 return in_array($m, $modules);
}
/**
 * 生成SEO
 * @param $siteid  站点ID
 * @param $catid  栏目ID
 * @param $title  标题
 * @param $description 描述
 * @param $keyword  关键词
 */
function seo($siteid, $catid = '', $title = '', $description = '', $keyword = '') {
 if (!empty($title))$title = strip_tags($title);
 if (!empty($description)) $description = strip_tags($description);
 if (!empty($keyword)) $keyword = str_replace(' ', ',', strip_tags($keyword));
 $sites = getcache('sitelist', 'commons');
 $site = $sites[$siteid];
 $cat = array();
 if (!empty($catid)) {
  $siteids = getcache('category_content','commons');
  $siteid = $siteids[$catid];
  $categorys = getcache('category_content_'.$siteid,'commons');
  $cat = $categorys[$catid];
  $cat['setting'] = string2array($cat['setting']);
 }
 $seo['site_title'] =isset($site['site_title']) &amp;&amp; !empty($site['site_title']) ? $site['site_title'] : $site['name'];
 $seo['keyword'] = !empty($keyword) ? $keyword : $site['keywords'];
 $seo['description'] = isset($description) &amp;&amp; !empty($description) ? $description : (isset($cat['setting']['meta_description']) &amp;&amp; !empty($cat['setting']['meta_description']) ? $cat['setting']['meta_description'] : (isset($site['description']) &amp;&amp; !empty($site['description']) ? $site['description'] : ''));
 $seo['title'] = (isset($title) &amp;&amp; !empty($title) ? $title.' - ' : '').(isset($cat['setting']['meta_title']) &amp;&amp; !empty($cat['setting']['meta_title']) ? $cat['setting']['meta_title'].' - ' : (isset($cat['catname']) &amp;&amp; !empty($cat['catname']) ? $cat['catname'].' - ' : ''));
 foreach ($seo as $k=&gt;$v) {
  $seo[$k] = str_replace(array("\n","\r"), '', $v);
 }
 return $seo;
}
/**
 * 获取站点的信息
 * @param $siteid 站点ID
 */
function siteinfo($siteid) {
 static $sitelist;
 if (empty($sitelist)) $sitelist = getcache('sitelist','commons');
 return isset($sitelist[$siteid]) ? $sitelist[$siteid] : '';
}
/**
 * 生成CNZZ统计代码
 */
function tjcode() {
 if(!module_exists('cnzz')) return false;
 $config = getcache('cnzz', 'commons');
 if (empty($config)) {
  return false;
 } else {
  return '&lt;script src=\'http://pw.cnzz.com/c.php?id='.$config['siteid'].'&amp;l=2\' language=\'JavaScript\' charset=\'gb2312\'&gt;&lt;/script&gt;';
 }
}
/**
 * 生成标题样式
 * @param $style 样式
 * @param $html 是否显示完整的STYLE
 */
function title_style($style, $html = 1) {
 $str = '';
 if ($html) $str = ' style="';
 $style_arr = explode(';',$style);
 if (!empty($style_arr[0])) $str .= 'color:'.$style_arr[0].';';
 if (!empty($style_arr[1])) $str .= 'font-weight:'.$style_arr[1].';';
 if ($html) $str .= '" ';
 return $str;
}
/**
 * 获取站点域名
 * @param $siteid 站点id
 */
function siteurl($siteid) {
 static $sitelist;
 return WEB_PATH;
// if(!$siteid) return WEB_PATH;
// if(empty($sitelist)) $sitelist = getcache('sitelist','commons');
// return substr($sitelist[$siteid]['domain'],0,-1);
}
/**
 * 生成上传附件验证
 * @param $args 参数
 * @param $operation 操作类型(加密解密)
 */
function upload_key($args) {
 $pc_auth_key = md5(app_base::load_config('system','auth_key').$_SERVER['HTTP_USER_AGENT']);
 $authkey = md5($args.$pc_auth_key);
 return $authkey;
}
/**
 * 文本转换为图片
 * @param string $txt 图形化文本内容
 * @param int $fonttype 无外部字体时生成文字大小取值范围1-5
 * @param int $fontsize 引入外部字体时字体大小
 * @param string $font 字体名称 字体请放于app\libs\data\font下
 * @param string $fontcolor 字体颜色 十六进制形式 如FFFFFF,FF0000
 */
function string2img($txt, $fonttype = 5, $fontsize = 16, $font = '', $fontcolor = 'FF0000',$transparent = '1') {
 if(empty($txt)) return false;
 if(function_exists("imagepng")) {
  $txt = urlencode(sys_auth($txt));
  $txt = '&lt;img src="'.APP_PATH.'api.php?op=creatimg&amp;txt='.$txt.'&amp;f '.$version['pc_release'];
 }
}
/**
 * 运行钩子插件使用
 */
function runhook($method) {
 $time_start = getmicrotime();
 $data = '';
 $getpclass = FALSE;
 $hook_appid = getcache('hook','plugins');
 if(!empty($hook_appid)) {
  foreach($hook_appid as $appid =&gt; $p) {
   $pluginfilepath = CODE_PATH.'plugin'.DIRECTORY_SEPARATOR.$p.DIRECTORY_SEPARATOR.'hook.class.php';
   $getpclass = TRUE;
   include_once $pluginfilepath;
  }
  $hook_appid = array_flip($hook_appid);
  if($getpclass) {
   $pclass = new ReflectionClass('hook');
   foreach($pclass-&gt;getMethods() as $r) {
    $legalmethods[] = $r-&gt;getName();
   }
  }
  if(in_array($method,$legalmethods)) {
   foreach (get_declared_classes() as $class){
    $refclass = new ReflectionClass($class);
    if($refclass-&gt;isSubclassOf('hook')){
     if ($_method = $refclass-&gt;getMethod($method)) {
       $classname = $refclass-&gt;getName();
      if ($_method-&gt;isPublic() &amp;&amp; $_method-&gt;isFinal()) {
       plugin_stat($hook_appid[$classname]);
       $data .= $_method-&gt;invoke(null);
      }
     }
    }
   }
  }
  return $data;
 }
}
function getmicrotime() {
 list($usec, $sec) = explode(" ",microtime());
 return ((float)$usec + (float)$sec);
}
/**
 * 插件前台模板加载
 * Enter description here ...
 * @param unknown_type $module
 * @param unknown_type $template
 * @param unknown_type $style
 */
function p_template($plugin = 'content', $template = 'index',$style='default') {
 if(!$style) $style = 'default';
 $template_cache = app_base::load_sys_class('template_cache');
 $compiledtplfile = ROOT_PATH.'caches'.DIRECTORY_SEPARATOR.'caches_template'.DIRECTORY_SEPARATOR.$style.DIRECTORY_SEPARATOR.'plugin'.DIRECTORY_SEPARATOR.$plugin.DIRECTORY_SEPARATOR.$template.'.php';
 if(!file_exists($compiledtplfile) || (file_exists(CODE_PATH.'plugin'.DIRECTORY_SEPARATOR.$plugin.DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.$template.'.html') &amp;&amp; filemtime(CODE_PATH.'plugin'.DIRECTORY_SEPARATOR.$plugin.DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.$template.'.html') &gt; filemtime($compiledtplfile))) {
  $template_cache-&gt;template_compile('plugin/'.$plugin, $template, 'default');
 } elseif (!file_exists(CODE_PATH.'plugin'.DIRECTORY_SEPARATOR.$plugin.DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.$template.'.html')) {
  showmessage('Template does not exist.'.DIRECTORY_SEPARATOR.'plugin'.DIRECTORY_SEPARATOR.$plugin.DIRECTORY_SEPARATOR.$template.'.html');
 }
 return $compiledtplfile;
}
/**
 * 读取缓存动态页面
 */
function cache_page_start() {
 $relate_url = isset($_SERVER['REQUEST_URI']) ? safe_replace($_SERVER['REQUEST_URI']) : $php_self.(isset($_SERVER['QUERY_STRING']) ? '?'.safe_replace($_SERVER['QUERY_STRING']) : $path_info);
 define('CACHE_PAGE_ID', md5($relate_url));
 $contents = getcache(CACHE_PAGE_ID, 'page_tmp/'.substr(CACHE_PAGE_ID, 0, 2));
 if($contents &amp;&amp; intval(substr($contents, 15, 10)) &gt; SYS_TIME) {
  echo substr($contents, 29);
  exit;
 }
 if (!defined('HTML')) define('HTML',true);
 return true;
}
/**
 * 写入缓存动态页面
 */
function cache_page($ttl = 360, $isjs = 0) {
 if($ttl == 0 || !defined('CACHE_PAGE_ID')) return false;
 $contents = ob_get_contents();
 if($isjs) $contents = format_js($contents);
 $contents = "&lt;!--expiretime:".(SYS_TIME + $ttl)."--&gt;\n".$contents;
 setcache(CACHE_PAGE_ID, $contents, 'page_tmp/'.substr(CACHE_PAGE_ID, 0, 2));
}
/**
 *
 * 获取远程内容
 * @param $url 接口url地址
 * @param $timeout 超时时间
 */
function pc_file_get_contents($url, $timeout=30) {
 $stream = stream_context_create(array('http' =&gt; array('timeout' =&gt; $timeout)));
 return @file_get_contents($url, 0, $stream);
}
/**
 * Function get_vid
 * 获取视频信息
 * @param int $contentid 内容ID 必须
 * @param int $catid 栏目id 取内容里面视频信息时必须
 * @param int $isspecial 是否取专题的视频信息
 */
function get_vid($contentid = 0, $catid = 0, $isspecial = 0) {
 static $categorys;
 if (!$contentid) return false;
 if (!$isspecial) {
  if (!$catid) return false;
  $contentid = intval($contentid);
  $catid = intval($catid);
  $siteid = get_siteid();
  if (!$categorys) {
   $categorys = getcache('category_content_'.$siteid, 'commons');
  }
  $modelid = $categorys[$catid]['modelid'];
  $video_content = app_base::load_model('video_content_model');
  $r = $video_content-&gt;get_one(array('contentid'=&gt;$contentid, 'modelid'=&gt;$modelid), 'videoid', 'listorder ASC');
  $video_store =app_base::load_model('video_store_model');
  return $video_store-&gt;get_one(array('videoid'=&gt;$r['videoid']));
 } else {
  $special_content = app_base::load_model('special_content_model');
  $contentid = intval($contentid);
  $video_store =app_base::load_model('video_store_model');
  $r = $special_content-&gt;get_one(array('id'=&gt;$contentid), 'videoid');
  return $video_store-&gt;get_one(array('videoid'=&gt;$r['videoid']));
 }
}
/**
 * Function dataformat
 * 时间转换
 * @param $n INT时间
 */
 function dataformat($n) {
 $hours = floor($n/3600);
 $minite = floor($n%3600/60);
 $secend = floor($n%3600%60);
 $minite = $minite &lt; 10 ? "0".$minite : $minite;
 $secend = $secend &lt; 10 ? "0".$secend : $secend;
 if($n &gt;= 3600){
  return $hours.":".$minite.":".$secend;
 }else{
  return $minite.":".$secend;
 }
 }
 function httpResponse($status, $msg=''){
  $m = app_base::load_model('category_model');
  $CATEGORYS = $m-&gt;select(array('parentid'=&gt;0),'*','','listorder');
  include CODE_PATH . 'libs'.DIRECTORY_SEPARATOR.'data'.DIRECTORY_SEPARATOR.'http'.DIRECTORY_SEPARATOR.$status.'.php';
 }
 function array_change_key_case_recursive($arr)
 {
  if(! $arr || !is_array($arr))return array();
 return array_map(function($item){
  if(is_array($item))
   $item = array_change_key_case_recursive($item);
  return $item;
 },array_change_key_case($arr));
 }
 function visitauth(){
  $vtime = time();
 $vsign = md5("cuichuande@ideadata.com.cn#$%" . $vtime);
 return "tm={$vtime}&amp;sn={$vsign}";
 }
?&gt;
</pre>
<p>更多关于PHP相关内容感兴趣的读者可查看本站专题《php程序设计安全教程》、《php安全过滤技巧总结》、《PHP运算与运算符用法总结》、《PHP网络编程技巧总结》、《PHP基本语法入门教程》、《php面向对象程序设计入门教程》、《php字符串(string)用法总结》、《php+mysql数据库操作入门教程》及《php常见数据库操作技巧汇总》</p>
<p>希望本文所述对大家PHP程序设计有所帮助。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索php<br />
                    ，                数据<br />
                    ，                提交<br />
                                    过滤<br />
                                    婴儿毛衣编织实例详解、abaqus工程实例详解、android创意实例详解、usb应用开发实例详解、c 编程实例详解，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-02 05:41:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.iamivan.net/tag/%e6%8f%90%e4%ba%a4/" title="提交">提交</a>, <a href="https://www.iamivan.net/tag/%e8%bf%87%e6%bb%a4/" title="过滤">过滤</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PHP数据的提交与过滤基本操作实例详解_php技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3Z9N0z.html" rel="bookmark">PHP数据库表操作的封装类及用法实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP数据库表操作的封装类及用法.分享给大家供大家参考,具体如下: 数据库表结构: CREATE TABLE `test_user` ( `id` int(11) NOT NULL AUTO_INCREMENT, `username` varchar(45) NOT NULL, `password` varchar(45) NOT NULL, `nickname` varchar(45) NOT NULL, `r` tinyint(4) NOT NULL, PRIMARY KEY			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWWZKz.html" rel="bookmark">PHP文件上传操作实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例分析了PHP文件上传操作.分享给大家供大家参考,具体如下: 文件上传 发生在浏览器向服务器发出的请求中. 文件,对于浏览器来讲,就是表单中的一个特殊类型的数据而已. 浏览器表单中的数据,两种类型: 字符串类型(字节流编码) 文件类型(二进制编码),文件是表单数据中一部分 服务器角度: 在接受浏览器请求时,处理好表单内的数据.根据数据类型不同使用不同处理方法: 字符串类型,存储在$_POST变量中(内存) 文件型数据,存储在上传临时目录中 表单提交时,浏览器会默认的行为: 表单内的的内容都			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4v2Zz.html" rel="bookmark">php 自定义错误日志实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				php 自定义错误日志  项目中需要对定义错误日志及时处理, 那么就需要修改自定义错误日志的输出方式(写日志.发邮件.发短信)   一. register_shutdown_function(array('phperror','shutdown_function')); //定义PHP程序执行完成后执行的函数 函数可实现当程序执行完成后执行的函数,其功能为可实现程序执行完成的后续操作.程序在运行的时候可能存在执行超时,或强制关闭等情况,但这种情况下默认的提示是非常不友好的,如果使用registe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0RKvPz.html" rel="bookmark">Android AsyncTack 异步任务实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android AsyncTack 异步任务               这里写一个小实例,来学习巩固Android AsyncTack 异步任务的知识,以便在项目中使用. 介绍一下如何使用 1, 继承AsyncTask public class MyTask extends AsyncTask&lt;Params, Progrss, Result&gt; 我们来说一下这三个泛型的作用: Params: 调用异步任务时传入的类型 ; Progress : 字面意思上说是进度条, 实际上就是动态的由子线程向			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvnm2VM.html" rel="bookmark">php事务处理实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.php事务处理概述: 事务:是若干事件的集合事务处理:当所有事件执行成功,事务才执行;若有任何一个事件不能成功执行,事务的其它事件也不被执行. 只要你的MySQL版本支持BDB或InnoDB表类型,那么你的MySQL就具有事务处理的能力.这里面,又以InnoDB表类型用的最多,虽然后来发生了诸如Oracle收购InnoDB等令MySQL不爽的事情,但是这类商业事件与技术无关,下面就以InnoDB表类型为例简单说一下MySQL中的事务处理. 二.php事务处理代码: &lt;?php try{ $p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgEEa1z.html" rel="bookmark">PHP文件上传类实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP文件上传类.分享给大家供大家参考,具体如下: 这里演示了FileUpload.class.php文件上传类,其中用到了两个常量,可在网站配置文件中定义: define('ROOT_PATH',dirname(__FILE__)); //网站根目录 define('UPDIR','/uploads/'); //上传主目录 具体代码如下: &lt;?php //上传文件类 class FileUpload { private $error; //错误代码 private $maxsiz			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL0ZVM.html" rel="bookmark">php多线程实现方法及用法实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面我们来介绍具体php多线程实现程序代码,有需要了解的同学可参考. 当有人想要实现并发功能时,他们通常会想到用fork或者spawn threads,但是当他们发现php不支持多线程的时候,大概会转换思路去用一些不够好的语言,比如perl. 其实的是大多数情况下,你大可不必使用fork 或者线程,并且你会得到比用fork 或thread 更好的性能. 假设你要建立一个服务来检查正在运行的n台服务器,以确定他们还在正常运转.你可能会写下面这样的代码: 代码如下  &lt;?php $hosts = a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmVLylz.html" rel="bookmark">PHP信号量基本用法实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP信号量基本用法.分享给大家供大家参考,具体如下: 一些理论基础: 信号量:又称为信号灯.旗语 用来解决进程(线程同步的问题),类似于一把锁,访问前获取锁(获取不到则等待),访问后释放锁.临界资源:每次仅允许一个进程访问的资源.临界区:每个进程中访问临界资源的那段代码叫临界区进程互斥:两个或以上的进程不能同时进入关于同一组共享变量的临界区域,即一个进程正在访问临界资源,另一个进程要想访问必须等待.进程同步主要研究如何确定数个进程之间的执行顺序和避免数据竞争的问题 即,如何让多个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3Rkmp.html" rel="bookmark">PHP入门教程之上传文件实例详解&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了PHP上传文件的方法.分享给大家供大家参考,具体如下: Demo1.php &lt;form enctype=&quot;multipart/form-data&quot; action=&quot;Demo2.php&quot; method=&quot;post&quot;&gt; &lt;input type=&quot;hidden&quot; name=&quot;MAX_FILE_SIZE&quot; value=&quot;2000000&quot; /&gt; 上传文件: &			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqDYYb.html" rel="bookmark" class="title">Photoshop合成残酷的战争电影海报</a>
					<div>
						这次的主题是偏战争类毁灭类的,确实也是自己从来没有处理过的一个场景,个人觉得这种对画面感,远近景,氛围打造及颜色对比都可以起到很好的锻炼作用. 最终效果 找些类似的画面作为参考. 提炼关键词并寻找素材 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqmERM.html" rel="bookmark" class="title">SQL函数</a>
					<div>
						函数 SQL函数 使用SQL函数,您可以在一个SELECT语句的查询当中,直接计算数据库资料的平均值.总数.最小值.最大值.总和.标准差.变异数等统计.使用Recordset对象时,也可使用这些SQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5PB7M.html" rel="bookmark" class="title">分享使用爱站反链查询工具的见解</a>
					<div>
						雅虎外链查询关闭前,大部分站长都将此工具做为分析竞争对手的有力武器,但关闭后让很多站长一时不知如何分析竞争对手.最近爱站网正式推出了反链查询工具,小编将分享下使用爱站反链工具的心得,看看此工具的准确度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPYRRM.html" rel="bookmark" class="title">利用windows service 2003来创建多域间访问的搭建与架设（一）</a>
					<div>
						实验环境: 西安凌云高科技系统集成由限公司在日常办公之中使用的域是benet.Com(一个林):由于工程部最近接到了一个项目:搭建了一个域名为&quot;project.com&quot;(是另一个林 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx4jWb.html" rel="bookmark" class="title">魅族Flyme OS 3&period;4&period;5固件新功能：系统内置法语语言</a>
					<div>
						魅族Flyme OS 3.4.5最新固件正式发布,包含MX2/MX3(国内版)机型,系统内置法语语言是一大亮点,侧面印证了魅族进军法国市场的计划.更新信息和下载如下: MX2下载地址:http://d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2D7rM.html" rel="bookmark" class="title">5 个不能不看的 HTML5 &plus; JavaScript 效果</a>
					<div>
						自从苹果宣报放弃 Flash,并会采用新网页标准语法 HTML5,HTML5 就好像变了网络的未来一样.除了 Google 马上推出 HTML5 版本的 Youtube 外,网络上亦出现大量的 HTM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBOGKb.html" rel="bookmark" class="title">PS制作柔美的暗调紫色婚片</a>
					<div>
						紫色是非常鲜艳的颜色,单用紫色图片会比较单调,画面会过艳.用色的时候最好是用暗紫色,蓝紫色.如何运用得当画面也会很柔美. 原图 &lt;点小图查看大图&gt; 最终效果 &lt;点小图查看大图&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N3L0z.html" rel="bookmark" class="title">php使用wordwrap格式化文本段落的方法</a>
					<div>
						 这篇文章主要介绍了php使用wordwrap格式化文本段落的方法,涉及wordwrap函数的使用技巧,具有一定参考借鉴价值,需要的朋友可以参考下     本文实例讲述了php使用wordwrap格式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYR2N9p.html" rel="bookmark" class="title">苹果全新MacBook Pro触控条上手体验</a>
					<div>
						  苹果今天正式发布新一代13.15英寸MacBook Pro,最吸引眼球的改变自然就是用一条OLED屏幕取代了此前的F1-F12功能键. 苹果将其称之为Touch Bar,它能够根据应用的改变自动切 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7x8wM.html" rel="bookmark" class="title">Windows 8系统metro界面部分应用英文名</a>
					<div>
						  故障现象: 有时,大家在使用metro界面时发现界面里的一些磁名称序变成了英文? 解决方案: 1.首先打开控制面板,可以将鼠标放到桌面的右上角,点击&quot;设置&quot;,然后点击&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1QOxb.html" rel="bookmark" class="title">怎么手动清理mac缓存文件</a>
					<div>
						  如何手动清理mac缓存文件? 要清除用户缓存.浏览器缓存和系统缓存,请根据以下进行操作: 1.打开&quot;Finder&quot;窗口,然后点击菜单中的&quot;前往&quot;-&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB01az.html" rel="bookmark" class="title">笔记本Win7话筒没有声音怎么办？</a>
					<div>
						最近有许多笔记本Win7系统用户反映,笔记本话筒没有声音.这可怎么办?话筒没有声音就会直接导致我们无法与他人进行沟通.不过也别担心,小编这就来告诉你笔记本Win7系统话筒没有声音的解决办法. 方法/步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkG1j1p.html" rel="bookmark" class="title">腾讯全民Wi-Fi怎么用？</a>
					<div>
						  1)使用全民Wi-Fi其实很贱,大家只需要将购买的全民Wi-Fi插入台式机或者笔记本电脑的USB借口上,即可自动安装驱动,并快捷创建Wi-Fi. 2)大家可以使用手机等移动设备,扫描二维码进行连接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8Y1kb.html" rel="bookmark" class="title">win7系统无法识别的usb设备的处理方法</a>
					<div>
						  我们在使用win7系统的过程中,有时候我们插入了USB设备之后系统有时候就读不到,然后会提示说&quot;无法识别USB设备&quot;,那到底是设置的问题还是哪些问题呢?下面我们就来看看win7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo78ojb.html" rel="bookmark" class="title">酷狗怎么伴唱</a>
					<div>
						  酷狗怎么伴唱?现在,人们的生活离不开娱乐,很多人在业余时间都会K歌,并且分享到朋友圈.我们会用到K歌达人或者是全民K歌,而作为一款听歌软件的酷狗居然也有K歌的功能了,它也可以消除原音唱歌,也就是所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oGOwb.html" rel="bookmark" class="title">卢松松：巧用收藏夹做网络推广</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 收藏夹是个好东西,它不仅可以用来我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze60YVb.html" rel="bookmark" class="title">jsp跳转-struts&comma;javaEE中的地址跳转</a>
					<div>
						问题描述 struts,javaEE中的地址跳转 跪求: jsp跳转到login.action中老是出现404错误,The requested resource (/Test2/TestActionC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrQvoM.html" rel="bookmark" class="title">怎样在 Android 上手动备份你的短信&sol;彩信？</a>
					<div>
						如果你要换一部手机或升级你的系统,备份你的数据就变得至关重要.我们存储重要数据的位置之一就是我们的短信/彩信,不管是感情价值还是实用价值,备份它们是很有用的. 然而,不像照片.视频或音频文件可以相对容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3kvlz.html" rel="bookmark" class="title">请教如何获取控件的内存数据</a>
					<div>
						问题描述 请教如何获取控件的内存数据 比如按钮,按钮在内存中是有大小的,如何获取按钮的内存数据,从而从这些数据中匹配数据 解决方案 FindWindow找到按钮的句柄,用GetWindowRect获取 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AjXlz.html" rel="bookmark" class="title">黑色与透明</a>
					<div>
						            今天遇到了一个问题 解决了很久.是这样的,美术给的一张图,黑底彩图,RGB,没有alpha通道,使用src:alpha  dst:one的方式进行混合,法线这张图的黑色被滤掉了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR8dYp.html" rel="bookmark" class="title">Weblogic的config&period;xml文件详解&lpar;原创&rpar;</a>
					<div>
						config.xml 域的中心配置文件是 /domains/DOMAIN_NAME/config/config.xml 文件.它用于指定域的名称以及域中每个服务器实例.群集.资源和服务的配置参数设置. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd025b.html" rel="bookmark" class="title">fltk-undefined reference to &grave;&lowbar;Unwind&lowbar;Resume&amp;amp&semi;amp&semi;&num;39&semi;</a>
					<div>
						问题描述 undefined reference to `_Unwind_Resume' OS:windows 7IDE:codeblocks 12.12c complier:mingw32-gcc. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rVvKp.html" rel="bookmark" class="title">Linux系统小技巧（2）：利用ps工具统计CPU消耗高的进程和统计消耗CPU或者内存的百分比</a>
					<div>
						CPU消耗高往往是系统异常的一种表现.因为平常检查系统运行有哪些进程,都是使用ps工具.因此,出现这种情况时,如果能够通过ps工具搜寻出CPU消耗高的线程,则对进一步搜寻线索或者排查应该有帮助. 下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJ5Bnp.html" rel="bookmark" class="title">PMC 任命Edward Sharp为首席战略及技术官</a>
					<div>
						   2015年6月24日,引领大数据连接.传送以及存储,提供创新半导体及软件解决方案的PMC公司(纳斯达克代码:PMCS)近期宣布,已任命Edward Sharp为公司的首席战略及技术官,直接向PM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqgPWb.html" rel="bookmark" class="title">关于返射编程通过MethodInfo&period;Invoke返回自定义类型数据的疑问</a>
					<div>
						问题描述 stringmodelName=&quot;tempClass&quot;;//获取tempNameSpace.tempClass类Typet=Type.GetType(&quot;temp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNvVkM.html" rel="bookmark" class="title">《低功耗蓝牙开发权威指南》&mdash;&mdash;3&period;3节应用层</a>
					<div>
						3.3 应用层 控制器和主机之上是应用层.应用层规约(specification)定义了三种类型:特性(characteristic).服务(service)和规范(profile).这些规约均构建在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDn6OBM.html" rel="bookmark" class="title">运营商与云计算大坑</a>
					<div>
						最近,有两篇文章争锋相对,分别是&lt;深度:掉进云计算大坑的运营商,还爬得出来吗&gt;,和&lt;也谈运营商是否掉进云计算大坑&gt;,大体是从Verizon.CenturyLink及早些年AT& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0DBAp.html" rel="bookmark" class="title">《大数据管理概论》一导读</a>
					<div>
						|前 言 陈寅恪先生说:&quot;一时代之学术,必有其新材料与新问题.取用此材料,以研求问题,则为此时代学术之新潮流.治学之士,得预于此潮流者,谓之预流(借用佛教初果之名).其未得预者,谓之未入流. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6oLXM.html" rel="bookmark" class="title">北京交通委整顿旧版本打车软件 由官方版取代</a>
					<div>
						&quot;有乘客预约用车--愿给小费×元.&quot;这段语音播报,是出租车内经常听到的一句话.近日,新京报记者体验调查发现,一些乘客通过旧版打车软件预约出租车时,自愿向司机支付&quot;小费&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze04KVp.html" rel="bookmark" class="title">我的侠客站群盈利计划来试试吧</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 凡事预则立,不预则废.做站群也是如 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
